package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.HualalaCardBenefitsService;
import com.gxwebsoft.apps.entity.HualalaCardBenefits;
import com.gxwebsoft.apps.param.HualalaCardBenefitsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 会员权益控制器
 *
 * @author 科技小王子
 * @since 2023-01-08 12:22:50
 */
@Api(tags = "会员权益管理")
@RestController
@RequestMapping("/api/apps/hualala-card-benefits")
public class HualalaCardBenefitsController extends BaseController {
    @Resource
    private HualalaCardBenefitsService hualalaCardBenefitsService;

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:list')")
    @OperationLog
    @ApiOperation("分页查询会员权益")
    @GetMapping("/page")
    public ApiResult<PageResult<HualalaCardBenefits>> page(HualalaCardBenefitsParam param) {
        PageParam<HualalaCardBenefits, HualalaCardBenefitsParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaCardBenefitsService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(hualalaCardBenefitsService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:list')")
    @OperationLog
    @ApiOperation("查询全部会员权益")
    @GetMapping()
    public ApiResult<List<HualalaCardBenefits>> list(HualalaCardBenefitsParam param) {
        PageParam<HualalaCardBenefits, HualalaCardBenefitsParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaCardBenefitsService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(hualalaCardBenefitsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:list')")
    @OperationLog
    @ApiOperation("根据id查询会员权益")
    @GetMapping("/{id}")
    public ApiResult<HualalaCardBenefits> get(@PathVariable("id") Integer id) {
        return success(hualalaCardBenefitsService.getById(id));
        // 使用关联查询
        //return success(hualalaCardBenefitsService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:save')")
    @OperationLog
    @ApiOperation("添加会员权益")
    @PostMapping()
    public ApiResult<?> save(@RequestBody HualalaCardBenefits hualalaCardBenefits) {
        if (hualalaCardBenefitsService.save(hualalaCardBenefits)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:update')")
    @OperationLog
    @ApiOperation("修改会员权益")
    @PutMapping()
    public ApiResult<?> update(@RequestBody HualalaCardBenefits hualalaCardBenefits) {
        if (hualalaCardBenefitsService.updateById(hualalaCardBenefits)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:remove')")
    @OperationLog
    @ApiOperation("删除会员权益")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (hualalaCardBenefitsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:save')")
    @OperationLog
    @ApiOperation("批量添加会员权益")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<HualalaCardBenefits> list) {
        if (hualalaCardBenefitsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:update')")
    @OperationLog
    @ApiOperation("批量修改会员权益")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<HualalaCardBenefits> batchParam) {
        if (batchParam.update(hualalaCardBenefitsService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCardBenefits:remove')")
    @OperationLog
    @ApiOperation("批量删除会员权益")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (hualalaCardBenefitsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
